CLAX2  ; >>> THE PROGRAM HAS BEEN MOVED TO 6000H
 ; >>> THE TABLE HAS BEEN MOVED TO 7000H
 ; >>> THE STORAGE AREA HAS BEEN MOVED TO 8000H
 ;
 	ORG	6000H
 START	DI
 NEW	LD	A,03H
 	OUT	(07),A		; SYNTAX CORRECTED
 	CALL	READY
 	CALL	SELECT
 	CALL	DEBNCE
 	CALL	TABLOC
 	CALL	EPINIT
 CALLER	CALL	FUNCTN
 	PUSH	AF
 	CALL	DEBNCE
 	POP	AF
 	DEC	A
 	CALL	Z,READ
 	DEC	A
 	CALL	Z,BURN
 	DEC	A
 	JP	Z,NEW
 	DEC	A
 	JP	Z,QUIT
 	DEC	A
 	CALL	Z,VERIFY
 	JP	CALLER
 QUIT	LD	A,(IX)
 	OUT	(07),A
 	JP	LIGHTS
 ;
 TABLOC	DEC	A
 	SLA	A
 	SLA	A
 	SLA	A
 	SLA	A
 	RET
 ;
 EPINIT	LD	L,A	;LS BYTE OF TABLE ADDRESS
 	LD	H,70	;MS BYTE OF TABLE ADDRESS
 	PUSH	HL
 	POP	IX
 	LD	A,(IX)
 	OUT	(07),A
 	RET
 ;
 READ	LD	A,(IX+7)
 	OUT	(07),A
 	LD	HL,0000H
 	LD	IY,8000H
 LOOP	LD	A,H
 	OUT	(05),A
 	LD	A,L
 	OUT	(06),A
 	IN	A,(04)
 	LD	(IY),A
 	INC	HL
 	INC	IY
 	DEC	BC
 	LD	A,B
 	OR	C
 	JP	NZ,LOOP
 CLEAR1	XOR	A	; CLEAN UP A BEFORE RETURNING
 	RET
 ;
 BURN	LD	B,(IX+8)	; HI BYTE # ADD IN EPROM
 	LD	C,(IX+9)	; LO BYTE # ADD IN EPROM
 	LD	D,(IX+10)	; BURN TIME
 	LD	IY,8000H
 	LD	HL,0000H
 LEWP	LD	A,H
 	OUT	(05),A
 	LD	A,L
 	OUT	(06),A
 	LD	A,(IY)
 	OUT	(04),A
 	LD	A,(IX+1)
 	OUT	(07),A
 	LD	A,(IX+2)
 	OUT	(07),A
 	LD	A,(IX+3)
 	OUT	(07),A
 	CALL	DELAY
 	LD	A,(IX+4)
 	OUT	(07),A
 	LD	A,(IX+5)
 	OUT	(07),A
 	LD	A,(IX+6)
 	OUT	(07),A
 	LD	A,(IX+7)
 	OUT	(07),A
 	IN	A,(04)
 	CP	(IY)		; SYNTAX CORRECTED
 	PUSH	AF
 	CALL	NZ,NFG
 	POP	AF
 	JP	NZ,CLEAN2
 	INC	IY
 	INC	HL
 	DEC	BC
 	LD	A,B
 	OR	C
 	JP	NZ,LEWP
 CLEAN2	XOR	A	; CLEAN UP A BEFORE RETURNING
 	RET
 ;
 VERIFY	LD	IY,8000H
 	LD	B,(IX+8)
 	LD	C,(IX+9)
 	LD	A,(IX+7)
 	OUT	(07),A
 	LD	HL,0000H
 LUPE	LD	A,H
 	OUT	(05),A
 	LD	A,L
 	OUT	(06),A
 	IN	A,(04)
 	CP	(IY)		; SYNTAX CORRECTED
 	PUSH	AF
 	CALL	NZ,NFG
 	POP	AF
 	JP	NZ,CLEAN3
 	INC	HL
 	INC	IY
 	DEC	BC
 	LD	A,B
 	OR	C
 	JP	NZ,LUPE
 CLEAN3	XOR	A	; CLEAN UP A BEFORE RETURNING
 	RET
 ;
 DELAY	PUSH	DE
 OUTER	LD	E,2AH
 INNER	NOP
 	DEC	E
 	JP	NZ,INNER
 	DEC	D
 	JP	NZ,OUTER
 	POP	DE
 	RET
 ;
 READY	LD	HL,3C00H
 	LD	DE,3C01H
 	LD	BC,03FFH
 	LD	(HL),20H
 	LDIR
 	LD	HL,MSG1
 	LD	DE,SCREEN
 	CALL	DISPLY
 	LD	HL,0FFFFH
 SLOWER	DEC	HL
 	JP	NZ,SLOWER
 	RET
 ;
 SELECT	LD	HL,MSG2
 	LD	DE,SCREEN+128
 	CALL	DISPLY
 REKEY	CALL	KEYBRD
 	AND	A
 	JP	Z,REKEY
 	RET
 ;
 FUNCTN	LD	HL,MSG3
 	LD	DE,SCREEN+256
 	CALL	DISPLY
 REDOIT	CALL	KEYBRD
 	AND	A
 	JP	Z,REDOIT
 	RET
 ;
 NFG	LD	HL,MSG9
 	LD	DE,SCREEN+384
 	CALL	DISPLY
 	RET
 ;
 SCREEN	EQU	3C00H
 ;
 DISPLY	LD	A,(HL)
 	AND	A
 	JP	Z,DISEND
 	LD	(DE),A
 	INC	HL
 	INC	DE
 	JP	DISPLY
 DISEND	RET
 ;
 KEYPAD	EQU	3800H
 ;
 KEYBRD	LD	HL,3810H
 	LD	B,01H
 TRY	LD	A,(HL)
 	OR	00H
 	JP	Z,TRY
 	SRL	A
 LOOPER	SRL	A
 	JP	C,EXIT
 	INC	B
 	JP	LOOPER
 EXIT	LD	A,B
 	RET
 ;
 LIGHTS	JP	0000H
 ;
 DEBNCE	LD	A,(3810H)
 	OR	00H
 	JP	NZ,DEBNCE
 	RET
 ;
 ;
 MSG1	DEFM	'SYSTEM READY FOR USE'
 	DEFB	00H
 MSG2	DEFM	'SELECT EPROM (1 - 6)'
 	DEFB	00H
 MSG3	DEFM	'SELECT FUNCTION:    '
 MSG4	DEFM	'1 = READ EPROM      '
 MSG5	DEFM	'2 = BURN EPROM      '
 MSG6	DEFM	'3 = RESTART PROGRAM '
 MSG7	DEFM	'4 = END PROGRAM     '
 MSG8	DEFM	'5 = VERIFY EPROM    '
 	DEFB	00H
 MSG9	DEFM	'*** BURN FAILURE ***'
 	DEFB	00H
 ;
 	ORG	7000H	; TABLE LOCATION
 T2716	DEFB	003H	;00000011
 	DEFB	001H	;00000001
 	DEFB	0C0H	;11000000
 	DEFB	0C1H	;11000001
 	DEFB	0C0H	;11000000
 	DEFB	0C3H	;11000011
 	DEFB	003H	;00000011
 	DEFB	002H	;00000010
 	DEFB	01CH	;00011100
 	DEFB	0F8H	;11111000
 	DEFB	0E8H	;11101000
 	DEFS	5
 ;
 T2732	DEFB	003H	;00000011
 	DEFB	001H	;00000001
 	DEFB	0A1H	;10100001
 	DEFB	0A0H	;10100000
 	DEFB	0A1H	;10100001
 	DEFB	0A3H	;10100011
 	DEFB	003H	;00000011
 	DEFB	002H	;00000010
 	DEFB	00FH	;00001111
 	DEFB	0FFH	;11111111
 	DEFB	032H	;00110010
 	DEFS	5
 ;
 T68764	DEFB	0C3H	;11000011
 	DEFB	0C1H	;11000001
 	DEFB	0C1H	;11000001
 	DEFB	091H	;10010001
 	DEFB	0C1H	;11000001
 	DEFB	003H	;00000011
 	DEFB	003H	;00000011
 	DEFB	003H	;00000011
 	DEFB	01FH	;00011111
 	DEFB	0FFH	;11111111
 	DEFB	028H	;00101000
 	DEFS	5
 ;
 T27128	DEFB	003H	;00000011
 	DEFB	0A1H	;10100001
 	DEFB	0A1H	;10100001
 	DEFB	081H	;10000001
 	DEFB	0A1H	;10100001
 	DEFB	0A3H	;10100011
 	DEFB	0A3H	;10100011
 	DEFB	00FH	;00001111
 	DEFB	04FH	;01001111
 	DEFB	02DH	;00101101
 	DEFS	5
 ;
 ;
 ;
 	END	START
